diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
similarity index 89%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
index 303c19775..e2d25efd2 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
@@ -16,31 +16,30 @@ public class BlockModelAxisAligned<T extends Block> extends BlockModelStandard<T
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         Axis axis = BlockAxisAligned.metaToAxis(meta);
         switch(axis)
         {
-            case Y: // '\0'
+            case Y:
                 renderBlocks.uvRotateEast = 0;
                 renderBlocks.uvRotateWest = 0;
                 renderBlocks.uvRotateSouth = 0;
                 renderBlocks.uvRotateNorth = 0;
                 break;
 
-            case Z: // '\002'
+            case Z:
                 renderBlocks.uvRotateSouth = 1;
                 renderBlocks.uvRotateNorth = 1;
                 break;
 
-            case X: // '\002'
+            case X:
                 renderBlocks.uvRotateEast = 1;
                 renderBlocks.uvRotateWest = 1;
                 renderBlocks.uvRotateTop = 1;
                 renderBlocks.uvRotateBottom = 1;
                 break;
         }
-        renderStandardBlock(tessellator, block, x, y, z);
+        renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
         resetRenderBlocks();
 
         return true;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
similarity index 60%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
index a0efab567..59bf3ca95 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockBasket;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 
 public class BlockModelBasket<T extends BlockBasket> extends BlockModelStandard<T> {
     protected IconCoordinate fillTexture = TextureRegistry.getTexture("minecraft:block/basket/fill");
@@ -15,42 +16,42 @@ public class BlockModelBasket<T extends BlockBasket> extends BlockModelStandard<
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        AABB bounds = block.getBounds();
         // Render basket
         final float onePix = 1.0f / 16;
         final float basketHeight = onePix * 16;
 
         // Basket walls
-        block.setBlockBounds(0, 0, 0, 1, onePix, 1);
-        renderStandardBlock(tessellator, block, x, y, z); // Bottom
+        bounds.set(0, 0, 0, 1, onePix, 1);
+        renderStandardBlock(tessellator, bounds, x, y, z); // Bottom
 
         setRenderSide(Side.EAST, false);
         setRenderSide(Side.WEST, false);
         setRenderSide(Side.BOTTOM, false);
-        block.setBlockBounds(0, 0, 0, 1, basketHeight, onePix);
-        renderStandardBlock(tessellator, block, x, y, z); // North
-        block.setBlockBounds(0, 0, 1 - onePix, 1, basketHeight, 1); // south
-        renderStandardBlock(tessellator, block, x, y, z); // South
+        bounds.set(0, 0, 0, 1, basketHeight, onePix);
+        renderStandardBlock(tessellator, bounds, x, y, z); // North
+        bounds.set(0, 0, 1 - onePix, 1, basketHeight, 1); // south
+        renderStandardBlock(tessellator, bounds, x, y, z); // South
         renderBlocks.renderBitMask = 0;
 
         setRenderSide(Side.NORTH, false);
         setRenderSide(Side.SOUTH, false);
         setRenderSide(Side.BOTTOM, false);
-        block.setBlockBounds(0, 0, 0, onePix, basketHeight, 1);
-        renderStandardBlock(tessellator, block, x, y, z); // West
-        block.setBlockBounds(1 - onePix, 0, 0, 1, basketHeight, 1);
-        renderStandardBlock(tessellator, block, x, y, z); // East
-        block.setBlockBounds(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
+        bounds.set(0, 0, 0, onePix, basketHeight, 1);
+        renderStandardBlock(tessellator, bounds, x, y, z); // West
+        bounds.set(1 - onePix, 0, 0, 1, basketHeight, 1);
+        renderStandardBlock(tessellator, bounds, x, y, z); // East
+        bounds.set(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
         renderBlocks.renderBitMask = 0;
 
         final int height = block.getFillLevel(renderBlocks.blockAccess, x, y, z);
         // Interior
         if (height > 0)
         {
-            renderTopFace(tessellator, block, x, (y - 1) + onePix + onePix * height, z, fillTexture);
+            renderTopFace(tessellator, bounds, x, (y - 1) + onePix + onePix * height, z, fillTexture);
         }
 
-        block.setBlockBounds(0, 0, 0, 1, basketHeight, 1);
+        bounds.set(0, 0, 0, 1, basketHeight, 1);
 
         return true;
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
similarity index 79%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
index 518ce757f..dbf36818b 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.BlockBed;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 
 public class BlockModelBed<T extends Block> extends BlockModelStandard<T> {
     protected IconCoordinate underTexture = TextureRegistry.getTexture("minecraft:block/bed/bottom");
@@ -21,7 +22,7 @@ public class BlockModelBed<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
         renderBlocks.enableAO = true;
         renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
 
@@ -29,10 +30,10 @@ public class BlockModelBed<T extends Block> extends BlockModelStandard<T> {
         final int direction = BlockBed.getDirection(meta);
         final boolean isFootOfBed = BlockBed.isBlockFootOfBed(meta);
 
-        final double minY = block.minY;
-        block.minY += 0.1875D;
-        renderSide(tessellator, block, x, y, z, 1f, 1f, 1f, Side.BOTTOM, meta);
-        block.minY = minY;
+        final double minY = bounds.minY;
+        bounds.minY += 0.1875D;
+        renderSide(tessellator, bounds, x, y, z, 1f, 1f, 1f, Side.BOTTOM, meta);
+        bounds.minY = minY;
 
         if(direction == 0)
         {
@@ -46,33 +47,33 @@ public class BlockModelBed<T extends Block> extends BlockModelStandard<T> {
         {
             renderBlocks.uvRotateTop = 3;
         }
-        renderSide(tessellator, block, x, y, z, Side.TOP, meta);
+        renderSide(tessellator, bounds, x, y, z, Side.TOP, meta);
 
         renderBlocks.uvRotateTop = 0;
         final int f17 = isFootOfBed ? BlockBed.headOfBedMap[BlockBed.footToHeadMap[direction]] : BlockBed.headOfBedMap[direction];
 
-        if(f17 != 2 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, x, y, z - 1, 2)))
+        if(f17 != 2 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y, z - 1, 2)))
         {
             renderBlocks.flipTexture = direction == 3;
-            renderSide(tessellator, block, x, y, z, Side.NORTH, meta);
+            renderSide(tessellator, bounds, x, y, z, Side.NORTH, meta);
         }
 
-        if(f17 != 3 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, x, y, z + 1, 3)))
+        if(f17 != 3 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y, z + 1, 3)))
         {
             renderBlocks.flipTexture = direction == 1;
-            renderSide(tessellator, block, x, y, z, Side.SOUTH, meta);
+            renderSide(tessellator, bounds, x, y, z, Side.SOUTH, meta);
         }
 
-        if(f17 != 4 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, x - 1, y, z, 4)))
+        if(f17 != 4 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, bounds, x - 1, y, z, 4)))
         {
             renderBlocks.flipTexture = direction == 2;
-            renderSide(tessellator, block, x, y, z, Side.WEST, meta);
+            renderSide(tessellator, bounds, x, y, z, Side.WEST, meta);
         }
 
-        if(f17 != 5 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, x + 1, y, z, 5)))
+        if(f17 != 5 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, bounds, x + 1, y, z, 5)))
         {
             renderBlocks.flipTexture = direction == 0;
-            renderSide(tessellator, block, x, y, z, Side.EAST, meta);
+            renderSide(tessellator, bounds, x, y, z, Side.EAST, meta);
         }
         resetRenderBlocks();
         return true;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
similarity index 65%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
index d23e965f9..85baf689f 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.BlockBrazier;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
@@ -27,20 +28,20 @@ public class BlockModelBrazier<T extends BlockBrazier>
 
         renderBlocks.enableAO = true;
         renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
-        renderSide(tessellator, block, x, y, z, Side.NORTH, 0);
-        renderSide(tessellator, block, x, y, z, Side.SOUTH, 0);
-        renderSide(tessellator, block, x, y, z, Side.EAST, 0);
-        renderSide(tessellator, block, x, y, z, Side.WEST, 0);
-        renderSide(tessellator, block, x, y, z, Side.BOTTOM, 0);
+        AABB bounds = block.getBounds();
+        renderSide(tessellator, bounds, x, y, z, Side.NORTH, 0);
+        renderSide(tessellator, bounds, x, y, z, Side.SOUTH, 0);
+        renderSide(tessellator, bounds, x, y, z, Side.EAST, 0);
+        renderSide(tessellator, bounds, x, y, z, Side.WEST, 0);
+        renderSide(tessellator, bounds, x, y, z, Side.BOTTOM, 0);
 
         final double zFightOffset = 0.005;
-        block.setBlockBounds(-zFightOffset, -zFightOffset, -zFightOffset, 1 + zFightOffset, 1 + zFightOffset, 1 + zFightOffset);
-        renderSide(tessellator, block, x, y, z + 1, Side.NORTH, 0);
-        renderSide(tessellator, block, x, y, z - 1, Side.SOUTH, 0);
-        renderSide(tessellator, block, x - 1, y, z, Side.EAST, 0);
-        renderSide(tessellator, block, x + 1, y, z, Side.WEST, 0);
-        renderSide(tessellator, block, x, y - 1, z, Side.TOP, 0);
-        block.setBlockBounds(0, 0, 0, 1, 1, 1);
+        bounds.set(-zFightOffset, -zFightOffset, -zFightOffset, 1 + zFightOffset, 1 + zFightOffset, 1 + zFightOffset);
+        renderSide(tessellator, bounds, x, y, z + 1, Side.NORTH, 0);
+        renderSide(tessellator, bounds, x, y, z - 1, Side.SOUTH, 0);
+        renderSide(tessellator, bounds, x - 1, y, z, Side.EAST, 0);
+        renderSide(tessellator, bounds, x + 1, y, z, Side.WEST, 0);
+        renderSide(tessellator, bounds, x, y - 1, z, Side.TOP, 0);
         renderBlocks.enableAO = false;
 
         if (block.isBurning()) {
@@ -52,65 +53,66 @@ public class BlockModelBrazier<T extends BlockBrazier>
 
     @Override
     public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        AABB bounds = block.getBounds();
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, baseTexture);
+        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, baseTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, block, 0.0D, -1.0D, 0.0D, baseTexture);
+        renderTopFace(tessellator, bounds, 0.0D, -1.0D, 0.0D, baseTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, block, 0.0D, 0.0D, 1.0D, sideTexture);
+        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 1.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, block, 0.0D, 0.0D, -1.0D, sideTexture);
+        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, -1.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, block, 1.0D, 0.0D, 0.0D, sideTexture);
+        renderWestFace(tessellator, bounds, 1.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, block, -1.0D, 0.0D, 0.0D, sideTexture);
+        renderEastFace(tessellator, bounds, -1.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side) {
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side) {
         return true;
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
similarity index 71%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
index 17b00a8bc..0cdb12c72 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -14,23 +15,21 @@ public class BlockModelCactus<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-
         final float sidesOffset = 0.0625F;
 
-        block.setBlockBounds(sidesOffset, 0, 0, 1 - sidesOffset, 1, 1);
+        AABB bounds = block.getBounds();
+        bounds.set(sidesOffset, 0, 0, 1 - sidesOffset, 1, 1);
         setRenderSide(Side.SOUTH, false);
         setRenderSide(Side.NORTH, false);
-        renderStandardBlock(tessellator, block, x, y, z);
+        renderStandardBlock(tessellator, bounds, x, y, z);
         renderBlocks.renderBitMask = 0b111111;
 
-        block.setBlockBounds(0, 0, sidesOffset, 1, 1, 1 - sidesOffset);
+        bounds.set(0, 0, sidesOffset, 1, 1, 1 - sidesOffset);
         setRenderSide(Side.SOUTH, true);
         setRenderSide(Side.NORTH, true);
-        renderStandardBlock(tessellator, block, x, y, z);
+        renderStandardBlock(tessellator, bounds, x, y, z);
         renderBlocks.renderBitMask = 0;
 
-        block.setBlockBounds(0, 0, 0, 1, 1, 1);
         return true;
     }
     @Override
@@ -43,46 +42,47 @@ public class BlockModelCactus<T extends Block> extends BlockModelStandard<T> {
             float b = (float)(color & 0xff) / 255F;
             GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
         }
-        setBlockBoundsForItemRender();
+
+        AABB bounds = getBlockBoundsForItemRender();
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         final float sidesOffset = 0.0625F;
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
         tessellator.offsetTranslation(0.0F, 0.0F, sidesOffset);
-        renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
         tessellator.offsetTranslation(0.0F, 0.0F, -sidesOffset);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         tessellator.offsetTranslation(0.0F, 0.0F, -sidesOffset);
-        renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
         tessellator.offsetTranslation(0.0F, 0.0F, sidesOffset);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         tessellator.offsetTranslation(sidesOffset, 0.0F, 0.0F);
-        renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
         tessellator.offsetTranslation(-sidesOffset, 0.0F, 0.0F);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         tessellator.offsetTranslation(-sidesOffset, 0.0F, 0.0F);
-        renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
         tessellator.offsetTranslation(sidesOffset, 0.0F, 0.0F);
         tessellator.draw();
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
index 36486f348..1ee54fd96 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
@@ -12,7 +12,6 @@ public class BlockModelCandle<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         boolean isLit = (renderBlocks.blockAccess.getBlockMetadata(x, y, z) & 0b00000001) == 0;
         float brightness = isLit ? 1.0f : getBlockBrightness(renderBlocks.blockAccess, x, y, z);
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
similarity index 96%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
index 4bf567ec0..9112fc166 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
@@ -29,8 +29,6 @@ public class BlockModelCropsPumpkin<T extends Block> extends BlockModelStandard<
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
@@ -76,7 +74,7 @@ public class BlockModelCropsPumpkin<T extends Block> extends BlockModelStandard<
         tessellator.addVertexWithUV(xMin, yMin, zMax, uMin, vMax);
         tessellator.addVertexWithUV(xMin, yMin, zMin, uMax, vMax);
         tessellator.addVertexWithUV(xMax + extra, yMax, zMin, uMax, vMin);
-        if (meta >= 1) renderStandardBlock(tessellator, block, x, y, z);
+        if (meta >= 1) renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
         return true;
     }
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
index 5df1d6da5..812b707f6 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
@@ -28,7 +28,6 @@ public class BlockModelCropsWheat<T extends Block> extends BlockModelStandard<T>
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index 59349f711..6a7e29510 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -33,7 +33,6 @@ public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandar
         }
         final float yOffset = 0.0F;
 
-        setBlockBoundsForItemRender();
         GL11.glTranslatef(-0.5F, -0.5f, -0.5F);
 
         IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata);
@@ -88,8 +87,6 @@ public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandar
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        
         float brightness = 1.0f;
         if(!LightmapHelper.isLightmapEnabled()) {
         	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
